﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Runtime.CompilerServices;
using System.Text;

namespace MatrixDotNetLib
{
    public class MatrixLoginRequest
    {
        /// <summary>
        /// Gets or sets client device ID (optional, auto-generated if null)
        /// </summary>
        [JsonProperty("device_id")]
        public string DeviceId { get; set; }

        /// <summary>
        /// Gets or sets user identifier as string (optional)
        /// </summary>
        [JsonProperty("identifier")]
        public MatrixLoginIdentifier Identifier { get; set; }

        /// <summary>
        /// Gets or sets the device display name (optional, ignored if device is known)
        /// </summary>
        [JsonProperty("initial_device_display_name")]
        public string DeviceName { get; set; }

        /// <summary>
        /// Gets or sets the password (required if type=m.login.password)
        /// </summary>
        [JsonProperty("password")]
        public string Password { get; set; }

        /// <summary>
        /// Gets or sets the login token (required if type=m.login.token)
        /// </summary>
        [JsonProperty("token")]
        public string Token { get; set; }

        /// <summary>
        /// Sets the static dictionary of login types (required)
        /// </summary>
        [JsonProperty("type")]
        public string LoginType { get; set; }


    }
}
